//
//  Complex.cpp
//  Session 9
//
//  Created by Luis Angel on 5/28/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

class Complex
{
private:
	double realPart;
	double imaginaryPart;
	
public:
	/**
	 * @brief Default constructor.
	 */
	Complex()
	{
		realPart = 0;
		imaginaryPart = 0;
	}
	
	/**
	 * @brief Constructor with arguments.
	 */
	Complex( double r, double i )
	{
		realPart = r;
		imaginaryPart = i;
	}
	
	/**
	 * @brief Access to real part.
	 */
	double getRealPart() const
	{
		return realPart;
	}
	
	/**
	 * @brief Access to imaginary part.
	 */
	double getImaginaryPart() const
	{
		return imaginaryPart;
	}
	
	/**
	 * @brief Complex number addition.
	 */
	Complex plus( const Complex& c ) const
	{
		double r = realPart + c.getRealPart();
		double i = imaginaryPart + c.getImaginaryPart();
		
		Complex sum( r, i );
		return sum;
	}
	
	/**
	 * @brief Complex number subtraction.
	 */
	Complex minus( const Complex& c ) const
	{
		double r = realPart - c.getRealPart();
		double i = imaginaryPart - c.getImaginaryPart();
		
		Complex subtraction( r, i );
		return subtraction;
	}
	
	/**
	 * @brief Printing the complex number.
	 */
	void print() const
	{
		cout << "(" << realPart
		<< ", " << imaginaryPart << ")" << endl;
	}
};

int main1()
{
	Complex c1( 1, 2 );
	const Complex c2( 3, 1 );
	
	c1.print();
	c2.print();
	c2.plus( c1 ).print();
	c1.minus( c2 ).print();
	
	return 0;
}





