//
//  Point.cpp
//  Session 9
//
//  Created by Luis Angel on 5/28/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>
#include <cmath>

using namespace std;

class Point
{
public:
	double x;
	double y;
	
	/**
	 * @brief Default constructor.
	 */
	Point()
	{
		x = y = 0;		// Notice, using x and y without 'this'.
	}
	
	/**
	 * @brief Constructor with arguments.
	 */
	Point( double x, double y )
	{
		this->x = x;	// Notice, using 'this' with '->'.
		this->y = y;
	}
	
	/**
	 * @brief Distance function.
	 */
	double distance( const Point& p ) const
	{
		double diffX = this->x - p.x;
		double diffY = (*this).y - p.y;		// Notice 'this' with '*' and '.'.
		
		return sqrt( diffX*diffX + diffY*diffY );
	}
};


int main2()
{
	const Point p1;
	Point p2( 1, 1 );
	
	cout << p1.distance( p2 ) << endl;
	
	const Point *pPtr1;
	pPtr1 = new Point;	// A new point (using default constructor).
	Point *pPtr2;
	pPtr2 = new Point( 3, 4 );	// A new point (using constructor with arguments)
	
	cout << pPtr1->distance( *pPtr2 ) << endl;
	
	delete pPtr1;		// Remove dynamically created points.
	delete pPtr2;
	
	return 0;
}

