//
//  SalesPerson.cpp
//  Session 9
//
//  Created by Luis Angel on 5/28/15.
//  Copyright (c) 2015 Luis Angel. All rights reserved.
//

#include <iostream>

using namespace std;

/*
 * Class declaration.
 */

class SalesPerson
{
private:
	double sales[12];			// 12 monthly sales figures.
	double totalAnnualSales();	// Utility function.
	
public:
	SalesPerson();				// Constructors.
	SalesPerson( const double* s );
	void setSales();			// User supplies sales figures.
	void printAnnualSales();
};


/*
 * Class definition
 */

/**
 * @brief Constructor.
 */
SalesPerson::SalesPerson()
{
	for( int I = 0; I < 12; I++ )
		sales[I] = 0;
}

/**
 * @brief Constructor with argument.
 */
SalesPerson::SalesPerson( const double* s )
{
	for( int I = 0; I < 12; I++ )
		sales[I] = s[I];
}

/**
 * @brief Set the 12 montly sales.
 */
void SalesPerson::setSales()
{
	for( int I = 0; I < 12; I++ )
	{
		cout << "Enter sales amount for month " << (I+1) << ": ";
		cin >> sales[I];
	}
}

/**
 * @brief Private utility function.
 */
double SalesPerson::totalAnnualSales()
{
	double total = 0;
	for( int I = 0; I < 12; I++ )
		total += sales[I];
	return total;
}

/**
 * @brief Print total annual sales.
 */
void SalesPerson::printAnnualSales()
{
	cout << "\nThe total annual sales are: $" << totalAnnualSales() << endl;
}


int main0()
{
	
	SalesPerson s1;
	s1.setSales();
	s1.printAnnualSales();
	
	double arr[] = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 };
	SalesPerson s2( arr );
	s2.printAnnualSales();
	
    return 0;
}
